/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Download Statusbar.
 *
 * The Initial Developer of the Original Code is
 * Devon Jensen.
 *
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Devon Jensen <velcrospud@hotmail.com>
 *
 * folder.png from Windows 2000 Icon Theme by asifalirizwaan - kde-look.org
 * download_manager.png from Crystal_SVG by everaldo - kde-look.org
 *
 * Uninstall observer code adapted from Ook? Video Ook! extension by tnarik
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


var db_gDownloadManager;
//var db_totalFinished;
//var db_totalSize;
var db_queueNum;
var db_pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var db_miniMode = false;
var db_useGradients = true;
var db_speedColorsEnabled = false;
var db_speedDivision1, db_speedDivision2, db_speedDivision3;
var db_speedColor0, db_speedColor1, db_speedColor2, db_speedColor3;
var db_excludeList = new Array ( );
var db_clearList = new Array ( );
var db_ignoreList = new Array ( );
window.addEventListener("load", downbarInit, true);
window.addEventListener('unload', downbarClose, false);
window.addEventListener("focus", db_changeListener, false);
window.addEventListener("blur", db_hideOnBlur, true);
var db_strings;
//var db_loaded = false;

function downbarInit() {

	//if(db_loaded) return;
	//db_loaded = true;

	var downbarelem = document.getElementById("downbar");

	const db_dlmgrContractID = "@mozilla.org/download-manager;1";
	const db_dlmgrIID = Components.interfaces.nsIDownloadManager;
	db_gDownloadManager = Components.classes[db_dlmgrContractID].getService(db_dlmgrIID);

	var db_ds = db_gDownloadManager.datasource;
	downbarelem.database.AddDataSource(db_ds);

	//db_totalFinished = 0;
	//db_totalSize = 0;

	// Load localized strings
	db_strings = document.getElementById("downbarbundle");

	db_readPrefs();
	db_checkMiniMode();  // checkMiniMode calls setStyles, setStyles calls checkHeight and startInProgress
	
	var db_observerService = Components.classes["@mozilla.org/observer-service;1"]
	                                  .getService(Components.interfaces.nsIObserverService);
	//db_observerService.addObserver(db_dlObserver, "dl-progress", false);
	db_observerService.addObserver(db_dlObserver, "dl-done", false);
	//db_observerService.addObserver(db_dlObserver, "dl-cancel", false);
	//db_observerService.addObserver(db_dlObserver, "dl-failed", false);
	db_observerService.addObserver(db_dlObserver, "dl-start", false);
	// Quit observers don't work well if the browser window is not the last window closed
	//db_observerService.addObserver(db_quitObserver, "quit-application-requested", false);
	db_observerService.addObserver(db_quitObserver, "quit-application-granted", false);
	db_observerService.addObserver(db_uninstallObserver, "em-action-requested", false);
	
	try {
		var firstRun = db_pref.getBoolPref("downbar.function.firstRun");
		//var launchDLWin = db_pref.getBoolPref("downbar.function.launchOnClose");
		var oldVersion = db_pref.getCharPref("downbar.function.version"); // needs to be last because it's likely not there (throws error)
	} catch (e) {}
	
	if (firstRun) {
		db_pref.setBoolPref("browser.download.manager.showWhenStarting", false);
		db_pref.setBoolPref("browser.download.manager.showAlertOnComplete", false);
		db_pref.setBoolPref("downbar.function.firstRun", false);
		
		// Give first runner 2 months before the donate text shows up in the add-ons manager
		var now = ( new Date() ).getTime();
		db_pref.setCharPref("downbar.function.donateTextInterval", now);
		
		// Check if set to remember what is downloaded, if not, make warning
		var rememberDownloads = db_pref.getIntPref("browser.download.manager.retention");
		if(rememberDownloads == 0) 
			window.setTimeout(function(){db_confirmDLPref();}, 8000);		
	}

	// Show "About Dlsb" on first time this version is used - currversion 0.9.4
	// XXX need to add that donate text is shown again in addons mgr, set supressDonateText to false, Interval reset too
	
	var showAbout = false;
	if(oldVersion) {
		var oldVersionArray = oldVersion.split(".");
		if(oldVersionArray[0] < "0")
			showAbout = true;
		else if (oldVersionArray[0] == "0") {
			if(oldVersionArray[1] < "9")
				showAbout = true;
			else if(oldVersionArray[1] == "9") {
				if(oldVersionArray[2] < "4")
					showAbout = true;
			}
		}
	}
	else  // there was no pref set
		showAbout = true;
		
	if(showAbout) {
		window.open('chrome://downbar/content/aboutdownbar.xul', "downbar_about", 'chrome,dialog=no,resizable');
		db_pref.setCharPref("downbar.function.version", "0.9.4");
	}
	
	// The default hide key is CTRL+SHIFT+z  Doing it this way should allow the user to change it with the downbar pref, or with the keyconfig extension
	try {
		var hideKey = db_pref.getCharPref("downbar.function.hideKey");
		if(hideKey != "z")
			document.getElementById("key_togDownbar").setAttribute("key", db_pref.getCharPref("downbar.function.hideKey"));
	} catch(e) {}
	
	/*if(launchDLWin) {
		// This is another way I can launch dlmgr onclose instead of using the "quit-app" observers - both have problems
		//    This way won't work if there are more than 1 browser window open and user does file..exit
		window.setTimeout(function(){
			window.tryToClose = db_WindowIsClosingWrap;
			window.onclose = function onclose(event) {return db_WindowIsClosingWrap();}
		}, 2000);
	}*/
	
	// This was a third way to handle quiting stuff but is easily broken by changes in firefox
	// Use our modified closeWindow and goQuitApplication functions (originals in globalOverlay.js)
	//window.closeWindow = db_closeWindow;
	//window.goQuitApplication = db_goQuitApplication;

	// Developer features to be disabled
	//toJavaScriptConsole();
	//BrowserOpenExtensions('extensions');
	//document.getElementById("menu_FilePopup").parentNode.setAttribute("onclick", "if(event.button == 1) goQuitApplication();");

	window.removeEventListener("load", downbarInit, true);
}

function downbarClose() {

	var db_observerService = Components.classes["@mozilla.org/observer-service;1"]
	                                  .getService(Components.interfaces.nsIObserverService);
	
	db_observerService.removeObserver(db_dlObserver, "dl-done");
	db_observerService.removeObserver(db_dlObserver, "dl-start");
	db_observerService.removeObserver(db_quitObserver, "quit-application-granted");
	db_observerService.removeObserver(db_uninstallObserver, "em-action-requested");
	
	db_gDownloadManager.listener = null;
	
}

// Called when a window is focused.  Always keep the focused window receiving the download listener events
function db_changeListener() {
	db_gDownloadManager.listener = dbListener;

	db_checkHeight();
	db_updateMini();
	
	if (db_miniMode)
		window.document.getElementById("downbarMini").collapsed = false;
	else
		window.document.getElementById("downbar").collapsed = false;

}

// When a new window is opened, wait, then test if it is a browser window.  If so, collapse the downbar in the old window.  (It won't get updated anyway)
function db_hideOnBlur() {
	window.setTimeout("db_blurWait()", 100);
}

function db_blurWait() {
	var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);

	if (window != ww.activeWindow) {
		var wintype = ww.activeWindow.document.firstChild.getAttribute('windowtype');
		if (wintype == "navigator:browser" | wintype == "Download:Manager") {
			if (db_miniMode)
				window.document.getElementById("downbarMini").collapsed = true;
			else
				window.document.getElementById("downbar").collapsed = true;
		}
	}
}

// if there are more downloads than the queue allows, return false
function db_checkQueue() {
	var currDLs = db_gDownloadManager.activeDownloadCount;
	//d(currDLs);
	//d(db_queueNum);
	if (currDLs > db_queueNum)
		return false;
	else
		return true;
}

const db_dlObserver = {
  observe: function(subject, topic, state) {

  	//d(topic);
	var db_dl = subject.QueryInterface(Components.interfaces.nsIDownload);
	var elmpath = db_dl.targetFile.path;
	var fixedelmpath = elmpath.replace(/\\/g, "\\\\");  // The \ and ' get messed up in the command if they are not fixed
	fixedelmpath = fixedelmpath.replace(/\'/g, "\\\'");
	var db_fileext = elmpath.split(".").pop().toLowerCase();
	window.setTimeout("db_updateMini()", 444);
	db_updateProgressNow();  // sorta works - at least for image saves

	if (topic == "dl-start") {
		
		// If it's on the ignore list, don't show it on the downbar
		for (var i=0; i<=db_ignoreList.length; ++i) {
				if (db_fileext == db_ignoreList[i])	
					return;
		}

		var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
		var intNode = rdf.GetIntLiteral(1);
		db_setRDFProperty(elmpath, "DownbarShow", intNode);
/*
		var allowDLstart = db_checkQueue();
		//d(allowDLstart);
		if (!allowDLstart){
			var fixedelmpath = elmpath.replace(/\\/g, "\\\\");  // The \ and ' get messed up in the command if they are not fixed
			fixedelmpath = fixedelmpath.replace(/\'/g, "\\\'");
			window.setTimeout("db_stopit('" + fixedelmpath + "')", 100);
		}
*/
		//window.setTimeout("db_checkHeight()", 100);
		//window.setTimeout("db_startUpdateDLrepeat('" + fixedelmpath + "')", 100);
		db_startUpdateDLrepeat(elmpath);
		document.getElementById("downbar").hidden = false;
	}

	if (topic == "dl-done") {

		// add a small animation or blink with PREF
		var aElem = document.getElementById(elmpath);
		
		// Cound how many finished downloads
		//db_totalFinished = db_totalFinished + 1;

		// BROKEN
		// xxx get the file size from rdf - see fin tooltip
		/*try {  // in a try block because images from cache won't have a pSavedBytes
			// Count the size of finished downloads
			if (aElem.pSavedBytes) {
				if (aElem.pTotalBytes == "-1" | !aElem.pTotalBytes)
					db_totalSize = db_totalSize + parseInt(aElem.pSavedBytes / 1024);  // KB
				else
					db_totalSize = db_totalSize + parseInt(aElem.pTotalBytes / 1024);  // KB
			}
		} catch (e) {}*/

		//Prefs for auto remove and anti-virus
		try {
			var clearTime = db_pref.getIntPref("downbar.function.timeToClear");
			var shouldScan = db_pref.getBoolPref("downbar.function.virusScan");
		}
		catch (e) {}
		
		if(shouldScan) {

			var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
			if(wm.getMostRecentWindow("navigator:browser") != window) {  // Only want this executed once, so only do it with the most recent browser window
				return;
			}
			
			try {
				var defCharset = db_pref.getComplexValue("intl.charset.default", Components.interfaces.nsIPrefLocalizedString).data;
				var uniConv = Components.classes['@mozilla.org/intl/scriptableunicodeconverter'].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
				uniConv.charset = defCharset;
				var convertedPath = uniConv.ConvertFromUnicode(elmpath);
				elmpath = convertedPath;
			}
			catch(e) {}
			
			var excludeFiletype = false;
			for (var i=0; i<=db_excludeList.length; ++i) {
				if (db_fileext == db_excludeList[i])
					excludeFiletype = true;
			}
			
			if(!excludeFiletype) {	
				try {
					var AVProgLoc = db_pref.getCharPref("downbar.function.virusLoc");
					var AVArgs = db_pref.getCharPref("downbar.function.virusArgs");
					var AVExecFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
					var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
					
					// Arguments must be separated into an array
					var args = AVArgs.split(" ");
					// Put the path where it is supposed to be
					for (var i=0; i<args.length; ++i) {
						args[i] = args[i].replace(/%1/g, elmpath);
						args[i] = args[i].replace(/\[Path\]/g, elmpath);  // for backwards compatibility
					}
					
					AVExecFile.initWithPath(AVProgLoc);
					if (AVExecFile.exists()) {
						process.init(AVExecFile);
						process.run(false, args, args.length);
					}
					else {
						var db_notFound = db_strings.getString("AVnotFound");
						alert(db_notFound + AVProgLoc);
					}
				} catch (e) {
					var db_failedAV = db_strings.getString("failedAV");
					alert(db_failedAV);
					return;
				}
			}
		}
		
		// check if it's on the list of autoclear
		var autoClear = false;
		if(db_clearList[0] == "all" | db_clearList[0] == "*")
			autoClear = true;
		else {
			for (var i=0; i<=db_clearList.length; ++i) {
				if (db_fileext == db_clearList[i])
					autoClear = true;
			}
		}
		if(autoClear) {
			window.setTimeout(function(){db_animateDecide(elmpath, "clear", {shiftKey:false});}, clearTime*1000);
		}
    }
  }
}

const dbListener = {
		onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus) {
		},

		// This collects raw download data, don't use this this to calculate download statistics b/c it doesn't get called reliably (ie case where connection has dropped)
		onProgressChange : function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, 
									aCurTotalProgress, aMaxTotalProgress, aDownload) {

			var now = ( new Date() ).getTime();
			var progElem = document.getElementById(aDownload.targetFile.path);
			if (!progElem) {return;}
			
			// If we don't have any info saved yet, save the current info and return
			if (!progElem.pSavedBytes | !progElem.pLastUpdate | !progElem.pTotalBytes) {
				progElem.pSavedBytes = aCurTotalProgress;
				progElem.pOldSavedBytes = aCurTotalProgress;
				progElem.pTotalBytes = aMaxTotalProgress;
				progElem.pLastUpdate = now;
				return;
			}
			
			// only update every one second - xxx interval ADD PREF?
			if (now - progElem.pLastUpdate > 400) {
				// Now grab new values
				progElem.pSavedBytes = aCurTotalProgress;
				progElem.pTotalBytes = aMaxTotalProgress;
				progElem.pLastUpdate = now;

			}

		},

		onLocationChange : function(aWebProgress, aRequest, aLocation) {
		},

		onStatusChange : function(aWebProgress, aRequest, aStatus, aMessage) {
		},

		onSecurityChange : function(aWebProgress, aRequest, aState) {
		}
}

// This function waits until there is a valid element created for a download before it sends it off to the update repeat function
// (There is a variable lag between the download start notification and element creation
function db_startUpdateDLrepeat(dlElemID) {

	var progElem = document.getElementById(dlElemID);
	if(progElem) {
		db_updateDLrepeat(dlElemID);
		db_checkHeight();
	}
	else {  // the element is not yet available - try again in 100ms
		window.setTimeout(function(){db_startUpdateDLrepeat(dlElemID);}, 100);
	}
}

// Update inprogress downloads every sec, calls a timeout to itself at the end
function db_updateDLrepeat(progElemID) {
	var progElem = document.getElementById(progElemID);
	try {
		var testContext = progElem.getAttribute("context");  // just see if it's a valid element
	} catch(e) {return;}
	
	if(testContext == "progresscontext") {  // now see if it's an in progress element
		
		var fixedelmpath = progElemID.replace(/\\/g, "\\\\");  // The \ and ' get messed up in the command if they are not fixed
		fixedelmpath = fixedelmpath.replace(/\'/g, "\\\'");
		
		var newsize = progElem.pSavedBytes;
		var oldsize = progElem.pOldSavedBytes;
		var totalsize = progElem.pTotalBytes;
		if(!newsize | !oldsize | !totalsize) {
			progElem.pTimeout = window.setTimeout("db_updateDLrepeat('" + fixedelmpath + "')", 50);
			return;
		}
		var sizeChange = newsize - oldsize;

		// Fix and set the size downloaded so far
		var currkb = parseInt(newsize / 1024); // KBytes
		if(currkb > 1024)
			var currSize = db_convertToMB(currkb) + " MB";
		else 
			var currSize = currkb + " KB";
		progElem.lastChild.lastChild.lastChild.previousSibling.value = currSize;
		
		// Calculate speed (for both determined and undetermined downloads)
		var oldrate = parseInt(progElem.lastChild.lastChild.firstChild.nextSibling.value);
		var elapsed = 1000; // one sec
		var rate = (sizeChange * 1000 ) / elapsed;
		var kRate = rate / 1024; // KBytes/sec

		// The last 5 speeds are kept in a string on the download element (seperated by ,)
		// Make an array, push on the latest, shift off the oldest, calculate the avg speed over last 5 sec
		// Starts out with 'a' because that designates that we dont have 5 intervals yet
		// Keep track and divide by the number of valid (numeral, non-'a') speeds we have.
		if(!progElem.speedString)
			progElem.speedString = "a,a,a,a,a"
		
		var speedArray = progElem.speedString.split(",");
		speedArray.push(kRate);
		speedArray.shift();

		var speed5Total = 0;
		var validSpeedIntervals = 0;
		for (i = 0; i < speedArray.length; ++i) {
			if(speedArray[i] != "a") {
				validSpeedIntervals++;
				speed5Total = speed5Total + parseFloat(speedArray[i]);
			}
		}
		
		var speed5AVG = speed5Total / validSpeedIntervals;
		var fraction = parseInt( ( speed5AVG - ( speed5AVG = parseInt( speed5AVG ) ) ) * 10);
		var newrate = speed5AVG + "." + fraction;
		progElem.lastChild.lastChild.firstChild.nextSibling.value = newrate;
		newrate = parseFloat(newrate);
	
		progElem.speedString = speedArray.join(",");
		
		// the the mode is undetermined, just count up the MB
		if (progElem.pTotalBytes == "-1" | parseInt(newsize) > parseInt(progElem.pTotalBytes) ) {

			var db_unkAbbr = db_strings.getString("unknownAbbreviation");  // "Unk." in english
		
			// Percent and remaining time will be unknown
			progElem.lastChild.lastChild.firstChild.value = db_unkAbbr;
			progElem.lastChild.lastChild.lastChild.value = db_unkAbbr;
			
		}
		else {
			// Calculate percent
				//- do it here because of a bug in dlmanager that makes negitive percentages with large files
			var currpercent = parseInt(newsize * 100 / progElem.pTotalBytes);
			var newWidth = parseInt(currpercent/100 *  progElem.boxObject.width);
			progElem.firstChild.firstChild.minWidth = newWidth;
			progElem.lastChild.lastChild.firstChild.setAttribute("value", (currpercent + "%"));
			
			// Calculate and set the remaining time
			var remainingkb = parseInt((progElem.pTotalBytes - newsize) / 1024);
			if(newrate != 0) {
				var secsleft = (1 / newrate) * remainingkb;
				var remaintime = db_formatSeconds(secsleft);
				progElem.lastChild.lastChild.lastChild.value = remaintime;
			}
		}

		progElem.pOldSavedBytes = newsize;
		
		// Speed sensitive color
		if(db_speedColorsEnabled) {
			// Incremental
			var newcolor = db_speedColor0;
			if(newrate > db_speedDivision3)
				newcolor = db_speedColor3;
			else if (newrate > db_speedDivision2)
				newcolor = db_speedColor2;
			else if (newrate > db_speedDivision1)
				newcolor = db_speedColor1;
			
			if(db_useGradients)
				progElem.firstChild.firstChild.setAttribute("style", "background-color:" + newcolor + ";background-image:url(chrome://downbar/skin/whiteToTransGrad.png);border-right:0px solid transparent");
			else
				progElem.firstChild.firstChild.setAttribute("style", "background-color:" + newcolor + ";background-image:url();border-right:0px solid transparent");

			/*// Continuously Variable
			var baseRed = 0;
			var baseGreen = 0;
			var baseBlue = 254;
			var finalRed = 90;
			var finalGreen = 90;
			var finalBlue = 255;
			
			var maxSpeed = 700;
			var conversionRed = maxSpeed / (finalRed - baseRed);
			var conversionGreen = maxSpeed / (finalGreen - baseGreen);
			var conversionBlue = maxSpeed / (finalBlue - baseBlue);
			d("convR " + conversionRed);
			d("convG " + conversionGreen);
			d("convB " + conversionBlue);
			var newRed = parseInt(baseRed + newrate / conversionRed);
			var newGreen = parseInt(baseGreen + newrate / conversionGreen);
			var newBlue = parseInt(baseBlue + newrate / conversionBlue);
			if(newRed > 255)
				newRed = 255;
			if(newGreen > 255)
				newGreen = 255;
			if(newBlue > 255)
				newBlue = 255;
				
			d("newGreen: " + newGreen + "   " + "newRed: " + newRed);
			progElem.firstChild.firstChild.setAttribute("style", "background-color:rgb("+ newRed + "," + newGreen + "," + newBlue + ");");
		*/	
		}
		
		progElem.pTimeout = window.setTimeout("db_updateDLrepeat('" + fixedelmpath + "')", 1030);
	}
}

// The clicked-on node could be a child of the actual download element we want
// The child nodes won't have an id
function db_findDLNode(popupNode) {
	while(!popupNode.id) {
		popupNode = popupNode.parentNode;
	}
	return(popupNode.id);
}

function db_startOpenFinished(idtoopen) {
	
	if(db_useAnimation) {
		document.getElementById(idtoopen).firstChild.firstChild.src = "chrome://downbar/skin/greenArrow16.png";
		document.getElementById(idtoopen).firstChild.lastChild.firstChild.nextSibling.firstChild.nextSibling.id = "slidePic";
		document.getElementById(idtoopen).firstChild.lastChild.firstChild.nextSibling.lastChild.flex = "0";
		
		// Do shift to right, after right is done, it calls shift from left
		db_openFinishedContRight(idtoopen, 16);
		window.setTimeout(function(){db_finishOpen(idtoopen);}, 150);
	}
	else {
		db_finishOpen(idtoopen);
	}
}

function db_openFinishedContRight(idtoopen, currshift) {

	if(currshift < 0) {
		document.getElementById(idtoopen).firstChild.lastChild.firstChild.nextSibling.lastChild.flex = "1";
		document.getElementById(idtoopen).firstChild.lastChild.firstChild.nextSibling.firstChild.flex = "0";
		db_openFinishedContLeft(idtoopen, 16)
	}
	else {
		var styleAttr = "list-style-image:url('moz-icon:" + idtoopen + "');-moz-image-region:rect(0px " + currshift + "px 16px 0px);";
		document.getElementById("slidePic").setAttribute("style", styleAttr);
		window.setTimeout(function(){db_openFinishedContRight(idtoopen, currshift-2);}, 10);
	}
}

function db_openFinishedContLeft(idtoopen, currshift) {

	if(currshift < 0) {
		//d("exiting");
		//db_finishOpen(idtoopen);
		document.getElementById(idtoopen).firstChild.firstChild.src = "moz-icon:" + idtoopen;
		document.getElementById(idtoopen).firstChild.lastChild.firstChild.nextSibling.firstChild.nextSibling.id = "";
		document.getElementById(idtoopen).firstChild.lastChild.firstChild.nextSibling.firstChild.nextSibling.setAttribute("style", "");
		document.getElementById(idtoopen).firstChild.lastChild.firstChild.nextSibling.firstChild.flex = "1";
	}
	else {
		var styleAttr = "list-style-image:url('moz-icon:" + idtoopen + "');-moz-image-region:rect(0px 16px 16px " + currshift + "px);";
		document.getElementById("slidePic").setAttribute("style", styleAttr);
		window.setTimeout(function(){db_openFinishedContLeft(idtoopen, currshift-2);}, 10);
	}
}

function db_finishOpen(idtoopen) {
	
	var file = db_getLocalFileFromNativePathOrUrl(idtoopen);
	if(!file.exists()) {
		var browserStrings = document.getElementById("bundle_browser");
		document.getElementById("statusbar-display").label = db_strings.getString("fileNotFound");
    	window.setTimeout(function(){document.getElementById("statusbar-display").label = browserStrings.getString("nv_done");}, 3000);
		return;
	}
	
	try {
    	file.launch();
    } catch (ex) {
    	// if launch fails, try sending it through the system's external
    	// file: URL handler
    	db_openExternal(file);
    }
    
	try {
		var removeOnOpen = db_pref.getBoolPref("downbar.function.removeOnOpen");
		if (removeOnOpen) {
			db_animateDecide(idtoopen, "clear", {shiftKey:false});
		}
	} catch (e) {}
	
}

function db_startShowFile(idtoshow) {

	if(db_useAnimation) {
		document.getElementById(idtoshow).firstChild.lastChild.firstChild.nextSibling.firstChild.nextSibling.id = "picToShrink";
		document.getElementById("picToShrink").src = "moz-icon:" + idtoshow;
		document.getElementById(idtoshow).firstChild.firstChild.src = "chrome://downbar/skin/folder.png";
		document.getElementById("picToShrink").style.MozOpacity = .5;
		db_showAnimateCont(idtoshow, 16);
		window.setTimeout(function(){db_finishShow(idtoshow);}, 50);
	}
	else {
		db_finishShow(idtoshow);
	}
}

function db_showAnimateCont(idtoshow, newsize) {
	
	if(newsize < 8) {
		
		// put the icon back how it's supposed to be after 1 sec.
		window.setTimeout(function(){	try{
											document.getElementById("picToShrink").src = "";
											document.getElementById("picToShrink").setAttribute("style", "height:16px;width:16px;");
											document.getElementById(idtoshow).firstChild.firstChild.src = "moz-icon:" + idtoshow;
											document.getElementById("picToShrink").id = "";
										} catch(e){}
									}, 1000);
	}
	else {
		document.getElementById("picToShrink").setAttribute("style", "height:" + newsize + "px;width:" + newsize + "px;");
		window.setTimeout(function(){db_showAnimateCont(idtoshow, newsize-2);}, 25);
	}
}

function db_finishShow(idtoshow) {

	var file = db_getLocalFileFromNativePathOrUrl(idtoshow);
	try {
		file.reveal();
	} catch(e) {
		var parent = file.parent;
      if (parent) {
        db_openExternal(parent);
      }
	}
    
	try {
		var removeOnShow = db_pref.getBoolPref("downbar.function.removeOnShow");
		if (removeOnShow) {
			db_animateDecide(idtoshow, "clear", {shiftKey:false});
		}
	} catch (e) {}
}

function db_pause(elemid, aEvent) {
	try {
		if (aEvent.button == 2)	return;
	}
	catch (e) {}

	// these values get erased on the change of download state, need to keep them for the tooltip
	var dbelem = document.getElementById(elemid);
	var pSB = dbelem.pSavedBytes;
	var pTB = dbelem.pTotalBytes;

	db_gDownloadManager.pauseDownload(elemid);
	db_setAllDisplayItems();

	dbelem = document.getElementById(elemid);
	dbelem.pSavedBytes = pSB;
	dbelem.pTotalBytes = pTB;

}

function db_resume(elemid, aEvent) {
	try {
		if (aEvent.button == 2)	return;
	}
	catch (e) {}

	db_gDownloadManager.resumeDownload(elemid);
	//db_setAllDisplayItems();
	
	db_startUpdateDLrepeat(elemid);
}

function db_animateDecide(elemid, doWhenDone, event) {
	
	if(db_useAnimation && !event.shiftKey) {
		if(db_miniMode)
			db_clearAnimate(elemid, 1, 20, "height", doWhenDone);
		else
			db_clearAnimate(elemid, 1, 125, "width", doWhenDone);
	}
	
   	else {
   		if(doWhenDone == "clear")
   			db_clearOne(elemid);
   		//else if(doWhenDone == "remove")
   		//	db_removeit(elemid);
   		else
   			db_startDelete(elemid, event);
   	}
}

function db_clearAnimate(idtoanimate, curropacity, currsize, heightOrWidth, doWhenDone) {

	if(curropacity < .05) {
		if(doWhenDone == "clear")
			db_clearOne(idtoanimate);
		else
			db_finishDelete(idtoanimate);
		return;
	}
	document.getElementById(idtoanimate).style.MozOpacity = curropacity-.04;
	if(heightOrWidth == "width") {
		document.getElementById(idtoanimate).maxWidth = currsize-5.2;
		window.setTimeout(function(){db_clearAnimate(idtoanimate, curropacity-.04, currsize-5.2, "width", doWhenDone);}, 10);
	}
	else {
		document.getElementById(idtoanimate).maxHeight = currsize-0.8;
		window.setTimeout(function(){db_clearAnimate(idtoanimate, curropacity-.04, currsize-0.8, "height", doWhenDone);}, 10);
	}
	
}

function db_clearOne(idtoclear) {

	var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
	var intNode = rdf.GetIntLiteral(0);
	db_setRDFProperty(idtoclear, "DownbarShow", intNode);

	db_checkHeight();
	window.setTimeout("db_updateMini()", 444);
}

function db_clearAll() {

	var downbarelem = document.getElementById("downbar");
	var comparray = downbarelem.getElementsByAttribute("context", "donecontext"); // just using context as an indicator of that type of element
	var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
	var intNode = rdf.GetIntLiteral(0);
	for (i = 1; i <= comparray.length - 1; i) {
		try {
       		db_setRDFProperty(comparray[i].id, "DownbarShow", intNode);
       	} catch (e) {}
    }
	db_checkHeight();
	window.setTimeout("db_updateMini()", 444);
}

/*
// this does both remove one and remove all, depending on passed boolean - allofthem
function db_removeit(idtoremove, allofthem){

	var downbarelem = document.getElementById("downbar");
	var dbelems = document.getElementById("downbar").childNodes;

	db_gDownloadManager.startBatchUpdate();
	db_gDownloadManager.datasource.beginUpdateBatch();

	if (allofthem) {
		var comparray = downbarelem.getElementsByAttribute("context", "donecontext");
		for (i = 1; i <= comparray.length - 1; ++i) {
			try {
        		db_gDownloadManager.removeDownload(comparray[i].id);
        	} catch (e) {}
        	//downbarelem.removeChild(document.getElementById(comparray[i].id)); //hmm, this doesn't work right have to rebuild instead
        }
	}
	else {
		try {
			db_gDownloadManager.removeDownload(idtoremove);
		} catch (e) {}
		//downbarelem.removeChild(document.getElementById(idtoremove));
	}

	db_gDownloadManager.datasource.endUpdateBatch();
    db_gDownloadManager.endBatchUpdate();
    downbarelem.builder.rebuild();  // Would prefer to use removechild above but it doesn't work quite right when you download a file you already removed

    // Since the downbar was rebuilt, need to set the diplay again
    //db_setAllDisplayItems();
    db_checkHeight();
    window.setTimeout("db_updateMini()", 444);
}*/

function db_startDelete(elemtodelete, event) {

	try {
		var askOnDelete = db_pref.getBoolPref("downbar.function.askOnDelete");
	} catch (e) {}
	if (askOnDelete) {
		var db_confirmMsg = db_strings.getString("deleteConfirm");
		if (!confirm(db_confirmMsg))
			return;
	}
	
	if(db_useAnimation && !event.shiftKey) {
		document.getElementById(elemtodelete).firstChild.lastChild.firstChild.nextSibling.firstChild.nextSibling.src = "chrome://downbar/skin/delete1.png";
		window.setTimeout(function(){db_deleteAnimateCont(elemtodelete);}, 150);
	}
	else 
		db_finishDelete(elemtodelete);
	
}

function db_deleteAnimateCont(elemtodelete) {
	
	document.getElementById(elemtodelete).firstChild.lastChild.firstChild.nextSibling.firstChild.nextSibling.src = "chrome://downbar/skin/delete2.png";
	
	if(db_miniMode)
		db_clearAnimate(elemtodelete, 1, 20, "height", "delete");
	else
		db_clearAnimate(elemtodelete, 1, 125, "width", "delete");
}

function db_finishDelete(elemtodelete) {
	
	var file = db_getLocalFileFromNativePathOrUrl(elemtodelete);
	db_clearOne(elemtodelete);

	if (file.exists())
		file.remove(false); // false is the recursive setting
}

function db_cancelprogress(elemtocancel) {
	
	var dbelems = document.getElementById("downbar").childNodes;
	db_gDownloadManager.cancelDownload(elemtocancel);
	db_checkHeight();
	db_clearOne(elemtocancel);
	db_updateProgressNow();
	
	var localFile = db_getLocalFileFromNativePathOrUrl(elemtocancel);
	if (localFile.exists()) 
		localFile.remove(false);
}

function db_cancelAll() {

	var dbelems = document.getElementById("downbar").childNodes;
	var cancPos = new Array(); // hold the child id of elements that are canceled, so that they can be removed in the 2nd for loop
	var posCount = 1;
	var contextAttr;
	for (var i = 1; i <= dbelems.length - 1; ++i) {
			contextAttr = dbelems[i].getAttribute("context");
			if (contextAttr == "progresscontext" | contextAttr == "pausecontext") {  // just using context as an indicator of that type of element
				db_gDownloadManager.cancelDownload(dbelems[i].id);
				cancPos[posCount] = dbelems[i].id;
				++posCount;
			}
	}

	var localFile;
	// Need to clear them after the first for loop is complete
	for (var j = 1; j < posCount; ++j) {
		db_clearOne(cancPos[j]);
		localFile = db_getLocalFileFromNativePathOrUrl(cancPos[j]);
		if (localFile.exists()) 
			localFile.remove(false);
	}
	db_checkHeight();
}

function db_pauseAll() {
	var dbelems = document.getElementById("downbar").childNodes;
	var i = 1;
	// I don't know why a for loop won't work here but okay
	while (i < dbelems.length) {

		if (dbelems[i].getAttribute("context") == "progresscontext") { // just using context as an indicator of that type of element
			db_pause(dbelems[i].id, null);
		}
		i = i + 1;
	}
}

function db_resumeAll() {
	var dbelems = document.getElementById("downbar").childNodes;
	var i = 1;
	while (i < dbelems.length) {
		if (dbelems[i].getAttribute("context") == "pausecontext") {  // just using context as an indicator of that type of element
			db_resume(dbelems[i].id, null);
		}
		i = i + 1;
	}
}

function db_stopAll() {
	
	var dbelems = document.getElementById("downbar").childNodes;
	for (i = 1; i <= dbelems.length - 1; ++i) {
		if (dbelems[i].getAttribute("context") == "progresscontext") {  // just using context as an indicator of that type of element
			db_gDownloadManager.cancelDownload(dbelems[i].id);
		}
	}
}

function db_copyURL(elemtocopy) {

	const gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
														.getService(Components.interfaces.nsIClipboardHelper);
	gClipboardHelper.copyString(db_getRDFProperty(elemtocopy, "URL"));
}

function db_startit(elemid) {

	// This is how the new download manager does it, but it never resumes
	var src = db_getRDFProperty(elemid, "URL");
    var f = db_getLocalFileFromNativePathOrUrl(elemid);
    
    saveURL(src, f, null, true, true);
    
	/* This is how I used to do it - which magically resumes... sometimes
	var aElem = document.getElementById(elemid);
	var sourcepath = aElem.getAttribute("sourcepath");
	var aFilename = aElem.firstChild.value;
	var browser = top.document.getElementById("content");
  	browser.loadURI(sourcepath, getReferrer(document));
  	*/
}

function db_stopit(elemtostop) {
	db_gDownloadManager.cancelDownload(elemtostop);
	var f = db_getLocalFileFromNativePathOrUrl(elemtostop);
	if (f.exists())
		f.remove(false); // false is the recursive setting
		
	window.setTimeout("db_updateMini()", 444);
}

/*
// Now using db_getLocalFileFromNativePathOrUrl() in the hopes it will make stuff work on mac and linux - not tested
function db_createLocalFile(aFilePath)
{
  var lfContractID = "@mozilla.org/file/local;1";
  var lfIID = Components.interfaces.nsILocalFile;
  var lf = Components.classes[lfContractID].createInstance(lfIID);
  lf.initWithPath(aFilePath);
  return lf;
}*/

function db_setAllDisplayItems() {
	var dbelems = document.getElementById("downbar").childNodes;

	// Set the paused state and the display items
	for (i = 1; i <= dbelems.length - 1; ++i) {
		if (dbelems[i].getAttribute("context") == "progresscontext" || dbelems[i].getAttribute("context") == "pausecontext") {

			var percentC = db_gDownloadManager.getDownload(dbelems[i].id).percentComplete;
			var newWidth = parseInt(percentC/100 *  dbelems[i].boxObject.width);
			dbelems[i].firstChild.firstChild.minWidth = newWidth;
			//dbelems[i].firstChild.setAttribute("value", percentC);
			dbelems[i].lastChild.lastChild.firstChild.setAttribute("value", percentC + "%");
			dbelems[i].lastChild.lastChild.firstChild.nextSibling.value = 0;
		}
	}
}

// Shows/Hides the border of the downbar when it shows/hides(hides=nothing in it so it collapses)
function db_checkHeight() {

	var downbarelem = document.getElementById("downbar");
	try {
		var styleDefault = db_pref.getBoolPref("downbar.style.default");
		var downbarStyle = db_pref.getCharPref("downbar.style.db_downbar");
	} catch (e){}
	
	if(!db_miniMode) {
		if (downbarelem.boxObject.height > 10) {
			if(styleDefault)
				downbarelem.setAttribute("style", "");
			else
				downbarelem.setAttribute("style", downbarStyle);
		}
		else {
			//if(styleDefault)
			//	downbarelem.setAttribute("style", "border:0px solid threeDShadow");
			//else {	
				// We want to set the border to 0, so take everything in the pref except the border and add border-width=0px;
				// This only works when border is first in the list of the style preference
				//var cutoff = downbarStyle.indexOf(";") + 1;
				//var newTempStyle = "border-width:0px;" + downbarStyle.substring(cutoff, downbarStyle.length);
				downbarelem.style.setProperty("border-width", "0px", null);
				//downbarelem.setAttribute("style", newTempStyle);
			//}
		}
	}
}

function db_setStyles() {
	
	var downbarelem = document.getElementById("downbar");

	try {
		var styleDefault = db_pref.getBoolPref("downbar.style.default");
	} catch (e){}
	
	if(styleDefault) {
		//Set class back to what it is supposed to be and set style to nothing ("")
		downbarelem.setAttribute("style", "");
		downbarelem.firstChild.childNodes[0].firstChild.setAttribute("style", "");
		if(db_useGradients) {
			downbarelem.firstChild.childNodes[1].firstChild.setAttribute("style", "background-image:url(chrome://downbar/skin/whiteToTransGrad.png);");
			downbarelem.firstChild.childNodes[2].firstChild.setAttribute("style", "background-image:url(chrome://downbar/skin/whiteToTransGrad.png);");
			downbarelem.firstChild.childNodes[0].firstChild.firstChild.firstChild.setAttribute("style", "background-image:url(chrome://downbar/skin/whiteToTransGrad.png);");
			downbarelem.firstChild.childNodes[3].firstChild.firstChild.firstChild.setAttribute("style", "background-image:url(chrome://downbar/skin/whiteToTransGrad.png);");
			downbarelem.firstChild.childNodes[4].firstChild.setAttribute("style", "background-image:url(chrome://downbar/skin/whiteToTransGrad.png);");
		}
		else {
			downbarelem.firstChild.childNodes[1].firstChild.setAttribute("style", "");
			downbarelem.firstChild.childNodes[2].firstChild.setAttribute("style", "");
			downbarelem.firstChild.childNodes[0].firstChild.firstChild.firstChild.setAttribute("style", "");
			downbarelem.firstChild.childNodes[3].firstChild.firstChild.firstChild.setAttribute("style", "");
			downbarelem.firstChild.childNodes[4].firstChild.setAttribute("style", "");
		}
		downbarelem.firstChild.childNodes[3].firstChild.setAttribute("style", "");
		downbarelem.firstChild.childNodes[0].firstChild.firstChild.lastChild.setAttribute("style", "");
		downbarelem.firstChild.childNodes[3].firstChild.firstChild.lastChild.setAttribute("style", "");
		downbarelem.firstChild.childNodes[0].firstChild.lastChild.firstChild.setAttribute("style", "");
		downbarelem.firstChild.childNodes[3].firstChild.lastChild.firstChild.setAttribute("style", "");
		downbarelem.firstChild.childNodes[1].firstChild.lastChild.setAttribute("style", "");
		downbarelem.firstChild.childNodes[2].firstChild.firstChild.setAttribute("style", "");
		downbarelem.firstChild.childNodes[4].firstChild.firstChild.setAttribute("style", "");
		for(var i=0; i<4; ++i)
			downbarelem.firstChild.childNodes[0].firstChild.lastChild.lastChild.childNodes[i].setAttribute("style", "");
		for(var i=0; i<4; ++i)
			downbarelem.firstChild.childNodes[3].firstChild.lastChild.lastChild.childNodes[i].setAttribute("style", "");
		document.getElementById("db_widthSpacer").setAttribute("style", "min-width:125px;");
	
	}
	else {
		//Read custom prefs
		try {
			var downbarStyle = db_pref.getCharPref("downbar.style.db_downbar");
			var downbarPopupStyle = db_pref.getCharPref("downbar.style.db_downbarPopup");
			var progressStackStyle = db_pref.getCharPref("downbar.style.db_progressStack");
			var finishedHboxStyle = db_pref.getCharPref("downbar.style.db_finishedHbox");
			var notdoneHboxStyle = db_pref.getCharPref("downbar.style.db_notdoneHbox");
			var pausedHboxStyle = db_pref.getCharPref("downbar.style.db_pausedHbox");
			var progressbarStyle = db_pref.getCharPref("downbar.style.db_progressbar");
			var progressremainderStyle = db_pref.getCharPref("downbar.style.db_progressremainder");
			var filenameLabelStyle = db_pref.getCharPref("downbar.style.db_filenameLabel");
			var progressIndicatorStyle = db_pref.getCharPref("downbar.style.db_progressIndicator");
		} catch (e){}

		//Set styles to the new style - automatically overrides the class css rules
		if(db_miniMode)
			downbarelem.setAttribute("style", downbarPopupStyle);
		else
			downbarelem.setAttribute("style", downbarStyle);
		downbarelem.firstChild.childNodes[0].firstChild.setAttribute("style", progressStackStyle);
		downbarelem.firstChild.childNodes[1].firstChild.setAttribute("style", finishedHboxStyle);
		downbarelem.firstChild.childNodes[2].firstChild.setAttribute("style", notdoneHboxStyle);
		downbarelem.firstChild.childNodes[4].firstChild.setAttribute("style", notdoneHboxStyle);
		downbarelem.firstChild.childNodes[3].firstChild.setAttribute("style", pausedHboxStyle);
		downbarelem.firstChild.childNodes[0].firstChild.firstChild.firstChild.setAttribute("style", progressbarStyle);
		downbarelem.firstChild.childNodes[3].firstChild.firstChild.firstChild.setAttribute("style", progressbarStyle);
		downbarelem.firstChild.childNodes[0].firstChild.firstChild.lastChild.setAttribute("style", progressremainderStyle);
		downbarelem.firstChild.childNodes[3].firstChild.firstChild.lastChild.setAttribute("style", progressremainderStyle);
		downbarelem.firstChild.childNodes[0].firstChild.lastChild.firstChild.setAttribute("style", filenameLabelStyle);
		downbarelem.firstChild.childNodes[3].firstChild.lastChild.firstChild.setAttribute("style", filenameLabelStyle);
		downbarelem.firstChild.childNodes[1].firstChild.lastChild.setAttribute("style", filenameLabelStyle);
		downbarelem.firstChild.childNodes[2].firstChild.firstChild.setAttribute("style", filenameLabelStyle);
		downbarelem.firstChild.childNodes[4].firstChild.firstChild.setAttribute("style", filenameLabelStyle);
		for(var i=0; i<4; ++i)
			downbarelem.firstChild.childNodes[0].firstChild.lastChild.lastChild.childNodes[i].setAttribute("style", progressIndicatorStyle);
		for(var i=0; i<4; ++i)
			downbarelem.firstChild.childNodes[3].firstChild.lastChild.lastChild.childNodes[i].setAttribute("style", progressIndicatorStyle);
		
		var spacerW = parseInt(finishedHboxStyle.split(":")[2]);
		document.getElementById("db_widthSpacer").setAttribute("style", "min-width:" + spacerW + "px;");
	}	
//downbarelem.builder.rebuild();  db_checkHeight();
    window.setTimeout(function(){downbarelem.builder.rebuild();  db_checkHeight();  db_startInProgress();}, 10);  // Fixes bug #13537. Don't know why this is necessary, but it fixes a bug where the back button isn't available on the second page of a newly opened window
}

function db_stopTooltip(dlElem) {
	var elem = document.getElementById(dlElem);
	window.clearTimeout(elem.pTimeCode);
}

function db_makeTooltip(dlElem) {

	try {  // if there's an error, (the download completed) we won't continue calling settimeout
		var elem = document.getElementById(dlElem);
		var source = elem.getAttribute("pURL");
		var target = elem.id;
		var percent = elem.lastChild.lastChild.firstChild.value;
		var speed = elem.lastChild.lastChild.firstChild.nextSibling.value;

		var db_unkStr = db_strings.getString("unknown");

		if (elem.pSavedBytes && elem.pTotalBytes) {
			var currbytes = elem.pSavedBytes;
			var totalbytes = elem.pTotalBytes;

			var currkb = parseInt(currbytes / 1024); // KBytes
			var totalkb = parseInt(totalbytes / 1024); // KBytes
			var remainingkb = totalkb - currkb;
			
			if (currkb > 1024) 
				var currSize = db_convertToMB(currkb) + " MB";
			else 
				var currSize = currkb + " KB"
			
			if (totalkb > 1024) 
				var totalSize = db_convertToMB(totalkb) + " MB";
			else 
				var totalSize = totalkb + " KB"
		}
		else {
			var currkb = db_unkStr;
			var totalkb = db_unkStr;
		}

		var remaintime;
		if (speed == 0)  // Don't want to divide by zero
				remaintime = db_unkStr;
		else {
			var secsleft = (1 / speed) * remainingkb;
			var remaintime = db_formatSeconds(secsleft);
		}
		if (elem.pTotalBytes == "-1")  {  // If the mode is undetermined, we won't know these
			percent = db_unkStr;
			totalSize = db_unkStr;
			remaintime = db_unkStr;
		}

		document.getElementById("source").value = source;
		document.getElementById("target").value = target;
		document.getElementById("status").value = currSize + " of " + totalSize + " (at " + speed + " KB/sec)";
		document.getElementById("timeLeft").value = remaintime;
		document.getElementById("percentText").value = percent;

		elem.pTimeCode = window.setTimeout(function(){db_makeTooltip(dlElem);}, 1000);
	} catch(e) {
		document.getElementById("progresstip").hidePopup();
	}
}

/*function db_repeatDBtooltip() {

	if (document.tooltipNode.getAttribute("id") != "downbar") return false; // if we are on a progress elem we don't want to show this tooltip

	db_makeDBtooltip();
	var dbelem = document.getElementById("downbar");
	dbelem.dbIvalCode = window.setInterval("db_makeDBtooltip()", 1000);
	return true;
}

function db_stopDBtooltip() {
	var dbelem = document.getElementById("downbar");
	window.clearInterval(dbelem.dbIvalCode);
}

function db_makeDBtooltip() {

	var dbelem = document.getElementById("downbar");
	var dbelems = document.getElementById("downbar").childNodes;
	var unknownAdd = "";
	var numProg = 0;
	var sumProgSpeeds = 0;
	var sumProgSize = 0;
	var totalProgSize = 0;

	for (i = 1; i <= dbelems.length - 1; ++i) {
		if (dbelems[i].getAttribute("context") == "progresscontext") {
			numProg = numProg + 1;
			sumProgSpeeds = sumProgSpeeds + parseInt(dbelems[i].lastChild.lastChild.firstChild.nextSibling.value);
			sumProgSize = sumProgSize + dbelems[i].pSavedBytes;
			totalProgSize = totalProgSize + dbelems[i].pTotalBytes;

			if (dbelems[i].pTotalBytes == "-1")
				var db_unkTimeStr = db_strings.getString("unknownTime");
				unknownAdd = " + " + db_unkTimeStr;


		}
	}

	var currkb = parseInt(sumProgSize / 1024); // KBytes
	var totalkb = parseInt(totalProgSize / 1024); // KBytes

	var remainingkb = totalkb - currkb;
	var secsleft;
	if (sumProgSpeeds == 0 | totalProgSize == "-1")  // don't want to divide by zero
				secsleft = 0;
	else
				secsleft = (1 / sumProgSpeeds) * remainingkb;

	var remaintime = db_formatSeconds(secsleft);

	document.getElementById("numFinished").value = db_totalFinished;
	document.getElementById("sizeFinished").value = db_totalSize + " KB"; //BROKEN
	document.getElementById("numUnfinished").value = numProg;
	document.getElementById("speedUnfinished").value = sumProgSpeeds + " KB/sec";
	document.getElementById("timeUnfinished").value = remaintime + unknownAdd;
}*/

function db_makeFinTip(idtoview) {

	var url = db_getRDFProperty(idtoview, "URL");
	
	var dlSize = db_getRDFProperty(idtoview, "Transferred");
	dlSize = dlSize.split(" ")[0];
	dlSize = dlSize.substring(0, dlSize.length-2);  // Takes off "KB" so we can do math
	
	var startTime = db_getRDFProperty(idtoview, "DateStarted");
	// images saved from cache don't get a start time in ff2.0
	if(startTime) {
		var endTime = db_getRDFProperty(idtoview, "DateEnded");
		seconds = (endTime-startTime)/1000000;
		completeTime = db_formatSeconds(seconds);
		var avgSpeed = dlSize / seconds;
		avgSpeed = Math.round(avgSpeed*100)/100;  // two decimal points	
	}
	else {
		var db_unkStr = db_strings.getString("unknown");
		completeTime = db_unkStr;
		avgSpeed = db_unkStr;
	}
	
	if (dlSize > 1024) {
		dlSize = db_convertToMB(dlSize);
		dlSize = dlSize + " MB";
	}
	else
		dlSize = dlSize + " KB";
	

	if (completeTime == "00:00")
		completeTime = "<00:01";
		
	document.getElementById("finSource").value = url;
	document.getElementById("finTarget").value = idtoview;
	document.getElementById("finSize").value = dlSize;
	document.getElementById("finTime").value = completeTime;
	document.getElementById("finSpeed").value = avgSpeed + " KB/sec";
}

function db_convertToMB(size) {
	size = size/1024;
	size = Math.round(size*100)/100;  // two decimal points
	return size;
}

function db_formatSeconds(secs) {
// Round the number of seconds to remove fractions.
	secs = parseInt( secs + .5 );
	var hours = parseInt( secs/3600 );
	secs -= hours*3600;
	var mins = parseInt( secs/60 );
	secs -= mins*60;
	var result;

    if ( mins < 10 )
        mins = "0" + mins;
    if ( secs < 10 )
        secs = "0" + secs;

    if (hours) {
    	if ( hours < 10 ) hours = "0" + hours;
    	result = hours + ":" + mins + ":" + secs;
	}
	else result = mins + ":" + secs;

    return result;
}

function db_readPrefs() {
	// Get and save display prefs
	try {
		var percentDisp = db_pref.getBoolPref("downbar.display.percent");
		var speedDisp = db_pref.getBoolPref("downbar.display.speed");
		var sizeDisp = db_pref.getBoolPref("downbar.display.size");
		var timeDisp = db_pref.getBoolPref("downbar.display.time");
	} catch (e){}
	
	var downbarelem = document.getElementById("downbar");
	
	// set which text status is set on the templates for both progress and paused rules
	//percent
	downbarelem.firstChild.childNodes[0].firstChild.lastChild.lastChild.firstChild.hidden = !percentDisp;
	downbarelem.firstChild.childNodes[3].firstChild.lastChild.lastChild.firstChild.hidden = !percentDisp;
	//speed
	downbarelem.firstChild.childNodes[0].firstChild.lastChild.lastChild.firstChild.nextSibling.hidden = !speedDisp;
	downbarelem.firstChild.childNodes[3].firstChild.lastChild.lastChild.firstChild.nextSibling.hidden = !speedDisp;
	//size
	downbarelem.firstChild.childNodes[0].firstChild.lastChild.lastChild.lastChild.previousSibling.hidden = !sizeDisp;
	downbarelem.firstChild.childNodes[3].firstChild.lastChild.lastChild.lastChild.previousSibling.hidden = !sizeDisp;
	//time
	downbarelem.firstChild.childNodes[0].firstChild.lastChild.lastChild.lastChild.hidden = !timeDisp;
	downbarelem.firstChild.childNodes[3].firstChild.lastChild.lastChild.lastChild.hidden = !timeDisp;
	
	// Get the anti-virus filetype exclude list and num for queue
	try {
		var excludeRaw = db_pref.getCharPref("downbar.function.virusExclude");
		excludeRaw = excludeRaw.toLowerCase().replace(/\s/g,'');  // remove all whitespace
		db_excludeList = excludeRaw.split(",");
		//db_queueNum = db_pref.getIntPref("downbar.function.queueNum");
	} catch(e){}
	
	// Get autoClear and ignore filetypes
	try {
		var clearRaw = db_pref.getCharPref("downbar.function.clearFiletypes");
		clearRaw = clearRaw.toLowerCase().replace(/\s/g,'');  // remove all whitespace
		db_clearList = clearRaw.split(",");
		
		var ignoreRaw = db_pref.getCharPref("downbar.function.ignoreFiletypes");
		ignoreRaw = ignoreRaw.toLowerCase().replace(/\s/g,'');  // remove all whitespace
		db_ignoreList = ignoreRaw.split(",");
	} catch(e){}
	
	//Get SpeedColor settings
	try{
		db_speedColorsEnabled = db_pref.getBoolPref("downbar.style.speedColorsEnabled");
		if(db_speedColorsEnabled) {
			var speedRaw0 = db_pref.getCharPref("downbar.style.speedColor0");
			db_speedColor0 = speedRaw0.split(";")[1];
			// no division necessary should always be 0
			var speedRaw1 = db_pref.getCharPref("downbar.style.speedColor1");
			db_speedDivision1 = speedRaw1.split(";")[0];
			db_speedColor1 = speedRaw1.split(";")[1];
			var speedRaw2 = db_pref.getCharPref("downbar.style.speedColor2");
			db_speedDivision2 = speedRaw2.split(";")[0];
			db_speedColor2 = speedRaw2.split(";")[1];
			var speedRaw3 = db_pref.getCharPref("downbar.style.speedColor3");
			db_speedDivision3 = speedRaw3.split(";")[0];
			db_speedColor3 = speedRaw3.split(";")[1];
		}
	} catch(e){}
	
	// Open dlmgr onclose settings
	var db_observerService = Components.classes["@mozilla.org/observer-service;1"]
	                                  .getService(Components.interfaces.nsIObserverService);
	// first remove the observer to avoid adding duplicate observers
	try{
		db_observerService.removeObserver(db_gDownloadManager, "quit-application-requested");
	} catch(e){}
	try{
		var launchDLWin = db_pref.getBoolPref("downbar.function.launchOnClose");
	} catch(e){}
	// Add back the download manager observer if we don't want to control onclose downloads
	if(!launchDLWin)
		 db_observerService.addObserver(db_gDownloadManager, "quit-application-requested", false);
	// Animation setting
	try{
		db_useAnimation = db_pref.getBoolPref("downbar.function.useAnimation");
	} catch(e){}
	// Color Gradients Setting
	try{
		db_useGradients = db_pref.getBoolPref("downbar.style.useGradients");
	} catch(e){}
	try {
		db_miniMode = db_pref.getBoolPref("downbar.function.miniMode");
	} catch(e){}

	window.setTimeout(function(){downbarelem.builder.rebuild();}, 10); // fixes bug 13537, don't know why
}

function db_finishedClickHandle(aElem, aEvent) {

	if(aEvent.button == 0 && aEvent.shiftKey)
		db_renameFinished(aElem.id);
	
	if(aEvent.button == 1) {
		if(aEvent.ctrlKey)
			db_startDelete(aElem.id, aEvent);
		else
			db_animateDecide(aElem.id, "clear", aEvent);
	}
}

var db_aPromptObj = {value:""};

function db_renameFinished(elemid) {

	var rename = db_strings.getString("rename");
	var to = db_strings.getString("to");
	var promptTitle = db_strings.getString("renameTitle");
	var oldfilename = db_getRDFProperty(elemid, "Name");
	var ext = "";
	var oldArray = oldfilename.split(".");
	if(oldArray.length > 1)
		ext = oldArray.pop();
	var oldname = oldArray.join(".");
	if(ext != "")
		ext = "." + ext;
	
	var promptText = rename + "\n" + oldname + "\n" + to;
	db_aPromptObj.value = oldname;
	var ps = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var nameChanged = ps.prompt(window, promptTitle, promptText, db_aPromptObj, null, {value: null});
	
	if(nameChanged) {
		var file = db_getLocalFileFromNativePathOrUrl(elemid);
		var newfilename = db_aPromptObj.value + ext;
		if(oldfilename == newfilename)
			return;
		try {
			file.moveTo(null, newfilename);
		} catch(e) {
			// File not found
			var browserStrings = document.getElementById("bundle_browser");
			document.getElementById("statusbar-display").label = db_strings.getString("fileNotFound");
    		window.setTimeout(function(){document.getElementById("statusbar-display").label = browserStrings.getString("nv_done");}, 3000);
			return;
		}
		
		// fix the downloads.rdf graph
		var db_RDFC = '@mozilla.org/rdf/container;1';
		db_RDFC = Components.classes[db_RDFC].createInstance();
		db_RDFC = db_RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);
		
		var db_RDFCUtils = '@mozilla.org/rdf/container-utils;1';
		db_RDFCUtils = Components.classes[db_RDFCUtils].getService();
		db_RDFCUtils = db_RDFCUtils.QueryInterface(Components.interfaces.nsIRDFContainerUtils);
		
		var db_RDF = '@mozilla.org/rdf/rdf-service;1';
		db_RDF = Components.classes[db_RDF].getService();
		db_RDF = db_RDF.QueryInterface(Components.interfaces.nsIRDFService);
		
		var dsource = db_gDownloadManager.datasource;
		var dlRootNode = db_RDF.GetResource("NC:DownloadsRoot");
		try {
	      db_RDFC.Init(dsource,dlRootNode);
	    } catch (e) {
	      // it should always already be there
	      //ds_RDFCUtils.MakeSeq(dsource,dlRootNode);
	      //ds_RDFC.Init(dsource,dlRootNode);
	    }
	    
	    // get old and new resources, insert the new where the old one is, (old goes to +1)
		var oldRes = db_RDF.GetResource(elemid);
		var oldIndex = db_RDFC.IndexOf(oldRes);
		var newfile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    	newfile.initWithPath(file.parent.path);
		newfile.appendRelativePath(newfilename);
		var newRes = db_RDF.GetResource(newfile.path);
		
		db_RDFC.InsertElementAt(newRes, oldIndex, true);
		
		// Move the download properties we want to keep over to the new resource 
		var propertyArc, value;
		// xxx prob should enumerate ArcLabelsOut instead of this static array
		var dlProps = ["Transferred", "URL", "DateEnded", 
						"DownloadState", "ProgressPercent", "DownbarShow"];
		for (var i = 0; i < dlProps.length; ++i) {
			propertyArc = db_RDF.GetResource("http://home.netscape.com/NC-rdf#" + dlProps[i]);
			var target = dsource.GetTarget(oldRes, propertyArc, true);
			dsource.Move(oldRes, newRes, propertyArc, target);
		}
		// Images saved from cache don't have a DateStarted in ff2.0
		// This would be unnecessary if we enumerate ArcLabelsOut
		try {
			propertyArc = db_RDF.GetResource("http://home.netscape.com/NC-rdf#" + "DateStarted");
			var target = dsource.GetTarget(oldRes, propertyArc, true);
			dsource.Move(oldRes, newRes, propertyArc, target);
		} catch(e) {}
		
		db_RDFC.RemoveElementAt(oldIndex+1, true);
		
		// Unassert the name and file from the old resource, (we didn't move these)
		// now nothing pointing at the resource, it dies
		var nameArc = db_RDF.GetResource("http://home.netscape.com/NC-rdf#Name");
		var fileArc = db_RDF.GetResource("http://home.netscape.com/NC-rdf#File");
		var nameTarget = dsource.GetTarget(oldRes, nameArc, true);
		var fileTarget = dsource.GetTarget(oldRes, fileArc, true);
		dsource.Unassert(oldRes, nameArc, nameTarget);
		dsource.Unassert(oldRes, fileArc, fileTarget);

		// Give the new resource the proper name and file
		var newNameTarget = db_RDF.GetLiteral(newfilename);
		var newFileTarget = db_RDF.GetResource(newfile.path);
		dsource.Assert(newRes, nameArc, newNameTarget, true);
		dsource.Assert(newRes, fileArc, newFileTarget, true);
		
		// save the datasource
		var rdfsource = dsource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
		rdfsource.Flush();
		
		document.getElementById("downbar").builder.rebuild();
		
		// make the filename text bold for 2 sec - this way works for both default and custom styles
		var origStyle = document.getElementById(newfile.path).lastChild.getAttribute("style");
		var tempStyle = origStyle + "font-weight:bold;";
		
		document.getElementById(newfile.path).lastChild.setAttribute("style", tempStyle);
		window.setTimeout(function(){
			document.getElementById(newfile.path).lastChild.setAttribute("style", origStyle);
		}, 2000);
	}
}

function db_toggleDownbar() {

	var downbarelem = document.getElementById("downbar");
	if (downbarelem.hidden) {
		downbarelem.hidden = false;
		db_checkHeight();
	}
	else
		downbarelem.hidden = true;
}

// These two RDF functions slightly modified from built-in download manager - downloads.js in firefox 0.8
function db_setRDFProperty(aID, aProperty, aValue) {

	var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
	var db = db_gDownloadManager.datasource;
	var propertyArc = rdf.GetResource("http://home.netscape.com/NC-rdf#" + aProperty);
	var res = rdf.GetResource(aID);
	var node = db.GetTarget(res, propertyArc, true);

	if (node)
		db.Change(res, propertyArc, node, aValue);
	else
		db.Assert(res, propertyArc, aValue, true);
	var remoteDS = db.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
    remoteDS.Flush();
}

function db_getRDFProperty(aID, aProperty) {
	var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);

	var db = db_gDownloadManager.datasource;
	var propertyArc = rdf.GetResource("http://home.netscape.com/NC-rdf#" + aProperty);

	var res = rdf.GetResource(aID);
	var node = db.GetTarget(res, propertyArc, true);
	if (!node) return "";
	try {
		node = node.QueryInterface(Components.interfaces.nsIRDFLiteral);
		return node.Value;
	}
	catch(e) {
		try {
			node = node.QueryInterface(Components.interfaces.nsIRDFInt);
			return node.Value;
		}
		catch(e) {
			try {
				node = node.QueryInterface(Components.interfaces.nsIRDFResource);
				return node.Value;
			} catch(e) {
				node = node.QueryInterface(Components.interfaces.nsIRDFDate);
				return node.Value;
			}
			
		}
	}
	return "";
}

function db_trimHistory() {

	try {
		var shouldTrim = db_pref.getBoolPref("downbar.function.trimHistory");
		var limit = db_pref.getIntPref("downbar.function.numToTrim");
		var downloadRetention = db_pref.getIntPref("browser.download.manager.retention");
	} catch (e){}
	if(!shouldTrim)
		return;
	if(downloadRetention != 2) //Then it is clearing on close or on successful download and this will have no effect
		return;

	var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
	var ds = db_gDownloadManager.datasource;
	var dlRes = rdf.GetResource("NC:DownloadsRoot");
	var dlCont = Components.classes["@mozilla.org/rdf/container;1"].getService(Components.interfaces.nsIRDFContainer);
	//var mCUtils = Components.classes["@mozilla.org/rdf/container-utils;1"].getService(Components.interfaces.nsIRDFContainerUtils);
	//d(mCUtils.IsContainer(ds,dlRes));
	dlCont.Init(ds, dlRes);
	var numDL = dlCont.GetCount();

	if(numDL > limit) {
		//var diff = numDL - limit;
		//d(numDL + " - " + limit + " = " + diff);
		var allDownloads = dlCont.GetElements();

		for(i = 1; i <= limit; ++i) { // Downloads to keep
			allDownloads.getNext();
			//var resource2 = allDownloads.getNext();
			//d("keep: " + resource2.QueryInterface(Components.interfaces.nsIRDFResource).ValueUTF8);
		}
		var toRemove = new Array(); // hold the id of elements that are to be removed in the 2nd for loop
		var posCount = 1;
		while(allDownloads.hasMoreElements()) { // Downloads to get rid of
			var resource = allDownloads.getNext();
			//d("remove: " + resource.QueryInterface(Components.interfaces.nsIRDFResource).ValueUTF8);
			toRemove[posCount] = resource.QueryInterface(Components.interfaces.nsIRDFResource).ValueUTF8;
			posCount++;
		}

		db_gDownloadManager.startBatchUpdate();
		db_gDownloadManager.datasource.beginUpdateBatch();

		var dlState;
		for(var j = 1; j <= posCount - 1; ++j){
			try {
				dlState = document.getElementById(toRemove[j]).getAttribute("state");
				if (dlState == "1")  // check that it's not an active paused or stopped download
					db_gDownloadManager.removeDownload(toRemove[j]);
			} catch (e){db_gDownloadManager.removeDownload(toRemove[j]);} // canceled downloads not on the statusbar are fair game to be trimmed (it won't be active or paused)
		}
		db_gDownloadManager.datasource.endUpdateBatch();
    	db_gDownloadManager.endBatchUpdate();
	}
}

function db_checkMiniMode() {
	
	var currDownbar = document.getElementById("downbar").localName;
	if(db_miniMode) {
		
		if(currDownbar == "hbox") { // convert to miniMode
			var db_ds = db_gDownloadManager.datasource;
			document.getElementById("downbar").database.RemoveDataSource(db_ds);
			document.getElementById("downbar").id = "downbarHboxTemp";
			document.getElementById("downbarPopupTemp").id = "downbar";
			
			document.getElementById("downbar").database.AddDataSource(db_ds);
			document.getElementById("downbar").builder.rebuild();
			
			document.getElementById("downbarHboxTemp").builder.rebuild();  // gets rid of the download items that were already there on the old mode
																		   // Apparently this needs to be before the next line, where it is hidden or else causes a crash when del.ici.ous is installed
																		   // This line " var docStyleSheets =  document.styleSheets;" in del.ici.ous appears to be involved somehow, commentting it out also fixes crash
			document.getElementById("downbarHboxTemp").hidden = true;
			
			document.getElementById("downbarMini").collapsed = false;
			db_updateMini();
			db_readPrefs();
		}
		document.getElementById("changeModeContext").label = db_strings.getString("toFullMode");
	}
	else {
		if(currDownbar == "vbox") { // convert to fullMode
			var db_ds = db_gDownloadManager.datasource;
			document.getElementById("downbar").database.RemoveDataSource(db_ds);
			document.getElementById("downbar").id = "downbarPopupTemp";
			document.getElementById("downbarHboxTemp").id = "downbar";
			
			document.getElementById("downbar").database.AddDataSource(db_ds);
			document.getElementById("downbar").builder.rebuild();
			
			document.getElementById("downbarMini").collapsed = true;
			document.getElementById("downbarPopupTemp").builder.rebuild();  // gets rid of the download items that were already there on the old mode
			document.getElementById("downbar").hidden = false;
			db_readPrefs();
		}
		document.getElementById("changeModeContext").label = db_strings.getString("toMiniMode");
	}
	db_setStyles();
}

function db_updateMini() {
	
	var activeDownloads = db_gDownloadManager.activeDownloadCount;
	var dbelems = document.getElementById("downbar").childNodes;
	var finishedDownloads = dbelems.length - activeDownloads - 1;  //one for the template
	document.getElementById("downbarMiniText").value = activeDownloads + ":" + finishedDownloads;
	//downbarMini:  Collapsed if it isn't being used, hidden if it is being used but there is nothing in it
	if(activeDownloads + finishedDownloads == 0)
		document.getElementById("downbarMini").hidden = true;
	else
		document.getElementById("downbarMini").hidden = false;
}

function db_showMiniPopup(miniElem, event) {
	
	if(event.button == 0) 
		document.getElementById("downbarPopup").showPopup(miniElem,  -1, -1, 'popup', 'topright' , 'bottomright');
	
	var dbelems = document.getElementById("downbar").childNodes;
	for (var i = 1; i <= dbelems.length - 1; ++i) {
		contextAttr = dbelems[i].getAttribute("context");
		if (contextAttr == "progresscontext") {
			window.clearTimeout(dbelems[i].pTimeout);
			db_updateDLrepeat(dbelems[i].id);
		}
	}
}

function db_modeToggle() {
	
	db_pref.setBoolPref("downbar.function.miniMode", !db_miniMode);
	db_miniMode = !db_miniMode;
		
	db_checkMiniMode();
}

function db_updateProgressNow() {
	
	// Go through in progress downloads and update the progress right away
	var dbelems = document.getElementById("downbar").childNodes;
	var percent, newWidth;
	for (var i = 1; i <= dbelems.length - 1; ++i) {
		contextAttr = dbelems[i].getAttribute("context");
		if (contextAttr == "progresscontext") {
			//window.clearTimeout(dbelems[i].pTimeout);
			//db_updateDLrepeat(dbelems[i].id);
			percent = db_getRDFProperty(dbelems[i].id, "ProgressPercent");
			newWidth = parseInt(percent/100 *  dbelems[i].boxObject.width);
			dbelems[i].firstChild.firstChild.minWidth = newWidth;
		}
	}
}

// This is in case a new window is opened while a download is already in progress - need to start the update repeat
function db_startInProgress() {
	var dbelems = document.getElementById("downbar").childNodes;
	for (var i = 1; i <= dbelems.length - 1; ++i) {
		contextAttr = dbelems[i].getAttribute("context");
		if (contextAttr == "progresscontext") {
				db_startUpdateDLrepeat(dbelems[i].id);
		}
	}
	
}

function db_hideDownbarPopup() {
	try {
		// This is only for the miniDownbar - prevents the downbar popup from getting stuck after using the context menu on an item
		// gets called from the onpopuphidden of each download item context menu
		document.getElementById("downbarPopup").hidePopup();
	} catch(e){}
}

// this function and following comments from firefox 1.0.4 download manager 
// we should be using real URLs all the time, but until 
// bug 239948 is fully fixed, this will do...
function db_getLocalFileFromNativePathOrUrl(aPathOrUrl) {
  if (aPathOrUrl.substring(0,7) == "file://") {

    // if this is a URL, get the file from that
    ioSvc = Components.classes["@mozilla.org/network/io-service;1"]
      .getService(Components.interfaces.nsIIOService);

    // XXX it's possible that using a null char-set here is bad
    const fileUrl = ioSvc.newURI(aPathOrUrl, null, null).
      QueryInterface(Components.interfaces.nsIFileURL);
    return fileUrl.file.clone().
      QueryInterface(Components.interfaces.nsILocalFile);

  } else {

    // if it's a pathname, create the nsILocalFile directly
    f = Components.classes["@mozilla.org/file/local;1"].
      createInstance(Components.interfaces.nsILocalFile);
    f.initWithPath(aPathOrUrl);

    return f;
  }
}

var db_quitObserver = {
	observe: function(subject, topic, state) {
	
		//alert(topic);
		if(topic == "quit-application-granted") {
			
			if(db_pref.getBoolPref("downbar.toUninstall")) {
				db_pref.setBoolPref("browser.download.manager.showWhenStarting", true);
				db_pref.setBoolPref("browser.download.manager.showAlertOnComplete", true);
			}
			
			//window.open('chrome://mozapps/content/downloads/downloads.xul', "_blank", 'chrome,dialog=no,resizable');
			//toOpenWindowByType('Download:Manager', 'chrome://mozapps/content/downloads/downloads.xul', 'chrome,dialog=no,resizable');
			try {
				var launchDLWin = db_pref.getBoolPref("downbar.function.launchOnClose");
				var clearOnClose = db_pref.getBoolPref("downbar.function.clearOnClose");
			} catch(e){} 
			
			if(launchDLWin && db_gDownloadManager.activeDownloadCount > 0) {
				var dlWin = window.open('chrome://mozapps/content/downloads/downloads.xul', "_blank", 'chrome,dialog=no,resizable');
				// prevents the File...Exit "goquitApplication" from closing the new window
				dlWin.tryToClose = function(){return false;}
			}
			
			db_trimHistory();
			if(clearOnClose) {
				db_clearAll();
			}
		}
	}
};

var db_uninstallObserver = {
	observe: function(subject, topic, data) {
		subject = subject.QueryInterface(Components.interfaces.nsIUpdateItem);
		if ( (topic == "em-action-requested") && (subject.id == "{D4DD63FA-01E4-46a7-B6B1-EDAB7D6AD389}") ) {
			switch (data) {
    			case "item-uninstalled":
     				db_pref.setBoolPref("downbar.toUninstall", true);
    				break;
    			case "item-cancel-action":
     				db_pref.setBoolPref("downbar.toUninstall", false);
    				break;
    		}
		}
	}
};


// This function from firefox 1.5beta2
function db_openExternal(aFile)
{
  var uri = Components.classes["@mozilla.org/network/io-service;1"]
                      .getService(Components.interfaces.nsIIOService)
                      .newFileURI(aFile);

  var protocolSvc = 
      Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
                .getService(Components.interfaces.nsIExternalProtocolService);

  protocolSvc.loadUrl(uri);

  return;
}

function db_confirmDLPref() {
	
	var changeDownloadRetention = db_strings.getString("changeDLRetention");
	var changeConfirm = confirm(changeDownloadRetention);
	if (changeConfirm) {
		db_pref.setIntPref("browser.download.manager.retention", 2);
	}
}


/*
// This is another way I can launch dlmgr onclose instead of using the "quit-app" observers - both have problems
	//    This way won't work if there are more than 1 browser window open?
function db_WindowIsClosingWrap() {

	var shouldClose = WindowIsClosing();
	if(shouldClose) {
		//alert("shouldclose");
		
		try {
			var launchDLWin = db_pref.getBoolPref("downbar.function.launchOnClose");
			var clearOnClose = db_pref.getBoolPref("downbar.function.clearOnClose");
		} catch(e){}
		
		if(launchDLWin) {
			
			var windowCount = 0;
			var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
			                  .getService(Components.interfaces.nsIWindowMediator);
			var e = wm.getEnumerator("navigator:browser");
			while (e.hasMoreElements()) {
				var w = e.getNext();
				if (++windowCount == 2) 
				  break;
			}
			//alert(windowCount);
			if(windowCount == 1) {
				
				if(db_gDownloadManager.activeDownloadCount > 0) {
					var dlWin = window.open('chrome://mozapps/content/downloads/downloads.xul', "_blank", 'chrome,dialog=no,resizable');
					dlWin.tryToClose = function(){return false;}
				}
			}
		}
		if(clearOnClose)
			db_clearAll();
	}
	else{
		//alert("notclose");
	}
	
	return shouldClose;
}*/

//Wanted to drag and drop TO the filesystem, but it doesn't work
/*var db_dragDropObserver = {
	
	onDragStart: function (event, transferData, aDragAction) {
		var elem = event.target;
		while(elem.localName != "hbox")
			elem = elem.parentNode;
		d(elem.id);
		var localFile = db_createLocalFile(elem.id);
		d(localFile);
		d(localFile.path);
		//if (AVExecFile.exists()) {var fileObj = dataObj.value.QueryInterface(Components.interfaces.nsIFile);
		//var aDataStream = readDataFromFile( fileObj.path );
		
		var plainText = elem.id;
		
		aDragAction.action =
         Components.interfaces.nsIDragService.DRAGDROP_ACTION_COPY |
         Components.interfaces.nsIDragService.DRAGDROP_ACTION_MOVE |
         Components.interfaces.nsIDragService.DRAGDROP_ACTION_LINK;
		
		transferData.data=new TransferData();
		transferData.data.addDataForFlavour("application/x-moz-url",plainText);
		transferData.data.addDataForFlavour("text/html",plainText); 
		transferData.data.addDataForFlavour("application/x-moz-file",localFile);
		transferData.data.addDataForFlavour("text/unicode",plainText); 
		d("here");
	}
	
};*/
/*
function db_closeWindow(aClose) {
	
	var launchDLWin = db_pref.getBoolPref("downbar.function.launchOnClose");

	var windowCount = 0;
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var e = wm.getEnumerator(null);

	while (e.hasMoreElements()) {
		var w = e.getNext();
		++windowCount;
		if (windowCount == 2)
			break;
	}

	// If we're down to the last window and someone tries to shut down, check to make sure we can!
	if (windowCount == 1) {
		if(!launchDLWin && !canQuitApplication()) {
			return false;
		}
		// If there are active downloads and the pref is set, launch the download manager,
		// then allow the browser window to close
		if(launchDLWin && db_gDownloadManager.activeDownloadCount > 0)
			toOpenWindowByType('Download:Manager', 'chrome://mozapps/content/downloads/downloads.xul', 'chrome,dialog=no,resizable');
	}
	if (aClose){
		window.close();
	}

	downbarclose(windowCount);
	return true;
}

function db_goQuitApplication() {

  if (!canQuitApplication())
    return;

  downbarclose(1);

  var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
  var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
  var enumerator = windowManagerInterface.getEnumerator( null );
  var appShell = Components.classes['@mozilla.org/appshell/appShellService;1'].getService();
  appShell = appShell.QueryInterface( Components.interfaces.nsIAppShellService );

  var nativeAppSupport = null;
  try {
    nativeAppSupport = appShell.nativeAppSupport;
  }
  catch ( ex ) {
  }

  while ( enumerator.hasMoreElements()  )
  {
     var domWindow = enumerator.getNext();
     if (("tryToClose" in domWindow) && !domWindow.tryToClose())
       return false;
     domWindow.close();
  };
  if (!nativeAppSupport || !nativeAppSupport.isServerMode)
    appShell.quit(Components.interfaces.nsIAppShellService.eAttemptQuit);
  return true;
  
}*/


// Dump a message to Javascript Console
/*
function d(msg){
	var acs = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	acs.logStringMessage(msg);
}
*/